version 2.8.0
1.refacted disconnect reason words, clear and details now
2.fixed if user login with acc/pwd, try query user email 
3.fixed block list added block reason, and write it to log file
4.fixed connected socket write data and need flush 
5.added disconnect socket, sync waiting until data transfer done
6.removed preview version using machine code login, duplicated login reason
7.added login timeout/copy data, add ip to block list and disconnect it
8.fixed add all of disconnect reasons user to database, include no login user

version 2.7.9
1.fixed using qtimer entity replaced of single shot login timer
2.added data identifier make sure data packet use single time
3.removed patch variable, it's not stable and network io is async
4.fixed only pure new user save account to ini file
5.fixed if user repeated/invalid login, login timer still working issue
6.fixed using uuid as network packet identifier, not incremental float
7.added network protocol version word for future update/modify
8.fixed if user login with emaill succussed, still tips waiting digital code
9.fixed save data to ini, sometimes not work issue

version 2.7.8
1.improved log message to file, using and cache member variable qfile
2.fixed using c++20 lambda capture value, auto fill using this keyword issue
3.added patterns cd-key days, season, half-year, year, week
4.fixed qcorotask set max thread count don't work issue
5.using local time zone format server time, timezone equal utc+8
6.added listen guard check if listen port already using
7.added block list records patch invalid data, logger and cache
8.removed socket connected state check flags use connecting state

version 2.7.7
1.added initizlizing failed show message box, repair/update client
2.added user use ndui/elvui plugin, ui scale need clamp with 0.58-0.76
3.fixed min required screen size to 720p, 1080p screen history value
4.fixed actually game plugin min required screen size is 1080p
5.added if player don't summon pet, auto summon pet1 in battle
6.adapted all availables screens size, ndui/elvui common scale with 0.71

version 2.7.5
1.try fixed sometimes player in vehicle or not, read local data error
2.renamed target/player alive in unit handle, added check player alive
3.removed under player big red words tip about summon/resurrection pet
4.fixed user sent digital email code, show cooldown with timer on client
5.added and check pet spell growl allowed and actived tips
6.fixed player don't fact to target, don't clear target issue
7.adapted digital code email on small screen mobile screen, updated styles 

version 2.7.3
1.added player entered any vehicle, auto close plugin if it's open state
2.removed cast boom spell chat box message tips, update tooltips
3.added player entered any vehicle, target check always return false
4.fixed patch variable, it's more safety transfer data now
5.added mythic 'Hall of Atonement' elite monster don't count summon
6.try fixed if battle pets to far relative to current target tips
7.updated readme.txt pet descriptions, keyboard layout version
8.fixed if user replace login, client still running on background

version 2.7.0
1.added dungeon 'Priory of the Sacred Flame' lastest boss ignore summon monsters
2.added character talent change tips within dungeon, mythic, raid and scenario
3.fixed special scenario queue don't need delay face target and clear
4.fixed pet's spell delay apply debuff blood lust can't tips work well
5.fixed blood lust aura removed anytime, it still tips in chat issue 
6.fixed dungeon the boss spells/auras apply always, changed to event one time
7.refacted pre-hunter spec functions within spell loader to pet spec
8.added target not boss spell dcsj hp limited, fixed reload work issue
9.fixed check player screen height equal issue, added game mode limit tips

version 2.6.5
1.updated pre-update functions moved to normailize update protocol
2.fixed user/cdkey windows update display charge left format time
3.added delay assert spell cast failed, if character need face target
4.added scenario broken available items, passed by invalid target
5.updated talents using best suit of damage client, updated readme.txt
6.fixed multiple target apply aura dc to unit, sometimes work issue
7.fixed if character power not enought, client try pressed key always
8.fixed settings window load local configs only single time from ctor 

version 2.6.2 release
1.fixed paint frame don't follow game client window size changed if initizlizing
2.review paint frame snapping and none pixel with game inner frame
3.added checkbox option for frame indicator with settings panel
4.added game screen decteced for multiple screens user and apply to all
5.added launcher check system enable transparency effects and disable it
6.fixed using high resolution icon display on title bar
7.updated downloader ui, and using high resolution icon, clean project
8.added connect guard if the port exceptions with other programs
9.fixed show frame if other programs overlay on left-top game screen

version 2.6.0
1.reset updater ui animation duration time, pre-init and tween for process
2.feature, painted box frame and info text display client ocr is running
3.fixed box frame edge snapping to game inner frame has tiny pixels issue
4.fixed box frame display need substract game client title bar height
5.added first launcher client and setup timer for initializing
6.fixed if game full screen, the box frame width and height issue
7.updated condition of enter showing paint frame/voices, refactor functions
8.fixed using 'Arial' font display text, compatible all of windows platforms
9.updated settings ui, sync with voices, and assistant key pressed tips

version 2.5.8 full release
1.reset default value for new player, update game plugin ui add snapping axis-y
2.refactor controller function auto close, add select for force show or option show
3.added two-way snapping client position when open client -> updater
4.added pre-update download require components when client initizlizing
5.added password with update package archive, pre-update and version update
6.fixed updater unzip from thread don't waiting the step unzip archive

version 2.5.4
1.added spec pet controller show state, the gray state as auto instead of single
2.fixed game plugin if player use the defense spell client still pressed key
3.refactor rename history name of variables, frames of loop move to game ctrl
4.added keyboard layout check and tips when addon loaded
5.fixed show 'no combat bat!' show/hide quickly if player on mount/unmount and so on
6.removed unused the overlay color indicator rectangle single/aoe/auto frame
7.added pet chinese status show tips, included need summon pet or resurrection pet

version 2.5.1 release
1.revert to normalize data, it's work well and passed by any screen tested
2.update readme.txt fixed Chinese words and system scale, chat edit box desc
3.used modernize qt5+ cmake commands instead of clion studio generated codes
4.add delay start download update packages, and show progress bar waiting state
5.fixed unzip the download packages, connect when thread finished, it work issue
6.base on personal vision, changed updater.exe main ui widget styles, positions
7.client refactor check update logic, add manual check update within settings panel
8.client add force update check, if the updater.exe required sync update
9.changed client ping and check was needed update version rate, almost precent 0.2

version 2.4.8
1.add instance abandon vote finished and passed handle game plugin ctrl
2.add local dev machines list, developer running don't need open wow client
3.fixed client auth interval if network disconnected first not work issue
4.add user switch apply new talents succussed, require check action8 layout
5.fixed laptop screen have physical offset on x-axis, need add empty pixels
6.update readme.txt removed multiple talents words, instead of clear-indication
7.update client game pixel line width from 130 up to 600, adapted 4k screen
8.fixed fetch laptop primary screen info and move to extra screen data error
9.add user choose addons directory valid game client and the retail version

version 2.4.3
1.add game pair equipment base require slot count check, tips on loaded&payload
2.add keystone mythic 'Priory of the Sacred flame' enemies spell focus tips
3.update readme.txt when open client app, waiting 10-20secs, change windows size 5secs
4.fixed count multiple enemies only single, the cache data always keep value
5.fixed client interval auth data validate if value was negative number
6.update readme.txt add apply damage talent spell adapted player haste
7.add client system tray tooltips when user pointer on damage helper tray icon

version 2.4.0
1.fixed game plugin min screen size require, it's all screen available now
2.increment the resize pixel from 45 up to 48, 45 units of data not enough
3.add game plugin options for blood lust casted tips and removed debuff tips
4.add game plugin options for battle cast spell dcsj selected auto or manual
5.removed when boss battle end, auto close loops, it's cast by player regen
6.removed multiple screen size scaled adapted, only work with none system scaled
7.fixed when player zoomed the game window, title bar size change by width
8.add requires ui settings, refactor client code, update readme.txt

version 2.3.8 release
1.adapted the best settings for new user, include game plugin and client
2.group the function two spec, spec hunter and spec pet, make pure available
3.update the newest hunter character macros, use edit macro instead delete-create
4.update game plugin ui, make best of available for the spec pet and user

version 2.3.7
1.fixed spec pet boom sequences, follow the best available usage of spells
2.removed the boom sequences cast spell slzl, make boom with full spells time
3.add dungeon require interrupts enemy cast spell, focus with voice tips

version 2.3.6
1.fixed player pre-think start boom sequences, always keep charge one dcsj
2.feature, add valid spell cast succussed cache gcd, get min value from list
3.feature, add player focus the chat edit box input, pause client key press
4.fixed player challenge failed, reset the dungeon not clear blood lust timer
5.add focus casting sound sfx, fire on the focus target casting can interrupt
6.update set the boom sequences time out up to 8secs, avoid sequences not done
7.add safety for find pet player aura, sometimes player's pet isn't exists


version 2.3.5
1.add auto delay close boom sequences when player cast end of spell xjsf
2.fixed auto keep aura klx3 invalid, it's always not work issue
3.add target not boss hp limit lower 6%, keep spell dcsj charge one
4.feature, hostile count module with spec pet, smart apply auras dcsj
5.fixed player completed challenge, do not cancel blood lust timer issue
6.add standard available offset time with pre-think start boom sequences 
7.refactor const data TARGET_SCAN_AURA to game, removed smart cast spell hr
8.add player pre-think start boom sequences, smart keep dcsj charge one
9.fixed client start boom sequences, don't keep aura kl charges three

version 2.3.4
1.add spec pet key setup, include action8 spell layout, character's macros
2.add voice tips when player's pet dead, clear current selected target
3.fixed dungeon action always switch to single target while in the mythic
4.removed spell hr sync waiting spell hydzh&xjsf, spell hr handle alone
5.fixed after boom sequences, cast spell hr freedom, can't close by ctrl

version 2.3.3
1.reset compare double precision to normal, game output data already normalize
2.fixed sometime when challenge failed, part of cache data not reset issue
3.add player dead->alive limit encounter boss battle only in dungeon mythic
4.add encounter boss battle sound sfx, part of spell cdr play sound
5.think, use spell jssj as assistant increment damage spell for apply buffs
6.fixed sometime when play near by enemy, rapid aura buffs not full issue
7.removed unused challenge's events, fixed player re-enter mythic timer issue
8.add delay-moving variable, adapted spell mzsj replace of jssj when delay-moving
9.fixed blood lust broadcast succeded events not stable report lots of logs
10.fixed facker adapter limit target's hp, use normailize logic process
11.fixed use double target talent, it's still count battle enemies issue

version 2.3.2
1.feature, add game normal cancel channeling/casting status macros on global fixed
2.removed props group data, removed unused spell bzsj, adapted pixels line width
3.fixed game plugin sometimes 'self' keywords not work well
4.changed damage aura extra fixed time to zero, it's delay logic loop
5.fixed tick timer when input value was navigate report game plugin bug

version 2.3.1
1.feature, add damage aura for succeed/casting/channeling check damages was done
2.fixed count hostile enemies, check is multiple api work on single issue
3.add player details power value, weather player power lower 40%, [24%,40%,60%,75%]
4.refactor facker gcd add start from set and end with method, removed backup scripts
5.fixed check unit health precent, lower 20% higher 80%, no target always true
6.client, review and refactor hunter's multiple/single target circles
7.fixed player enter world, count enemies parallel data initializing exceptions
8.removed damage aura asserting, using fixed time tail delay make sure spell done

version 2.3.0 [pet=single aoe=hunter]
1.add cast spell blood lust succussed or aura removed chat message tips/sound
2.update spec pet talents adapted pure single target data, key slots, macros, circles
3.add once boom spells casted, spell hr already cdr, setup conditions reuse
4.add after boom spells and the spell hr within cd, open refresh spell hr mode
5.fixed within the boom sequences, if started, need a flags to block repeat spells

version 2.2.9
1.reset game talents follow wcl website rank player's using&common
2.blocked unused spell bzsj, removed client use spell jssj fill circles
3.fixed key pressed and waiting, at least 10f, general equal 100ms
4.fixed loop dungeon info replaced to encounter_start/end check boss battle
5.fixed player finished mythic challenge and plugin still working
6.removed unused calc facker gcd when cast spell successed/target invalid
7.add special dungeon focus enemy casting spell and play voice tips
8.update block looping spell bfbz, require aura duration 5->4 seconds

version 2.2.8
1.fixed read target health percent always true if target not exists
2.fixed dark hunter rapid channel spell jssj not work well issue
3.client ui, fixed user/cdkey window display datetime use zero format
4.add mouseover focus functions, succussed send chat message tips
5.fixed focus changed, api UnitIsEnemy sometimes work wrong on player
6.replaced spell jssj&bfbz sync status to spell bfbz required full buffs
7.add cast prepare cast spell bfbz, spell jssj get dmdj buff and cast it
8.fixed cast spell bzsj later, do not need waiting game RTT response

version 2.2.7
1.update data protocol variable params move to first, make sure safety
2.fixed parallel action player toggle off and multiple target initializing
3.fixed player control toggle on/off, keep scan instances hostile enemies
4.fixed sync spell jssj&bfbz within range 5seconds not working well issue

version 2.2.6
1.fixed timer period init after user logon and game client not running issue
2.limited spec-pet max 30fps because app client always repeat key pressed
3.add spec-pet show 'No combat pet!' conditions include vehicle, mount
4.add action basic for multiple game-specs, refactor relation functions
5.fixed different game-spec switch, avoid read data size remind line tail 
6.fixed game-plugin player apply spec succussed refresh require data
7.fixed duplicated lua global&local variable same name, reference error
8.update set battle fps keep 30fps, no more fps need for game-spec data

version 2.2.5
1.fixed player interrupted condition only moving as count valid
2.adapted hunter spec-pet, test passed from scenario level11
3.fixed key assistant pressed not working within combating
4.add heal pet within combat while pet health less then 60%
5.fixed spend aura lqlxzh-fire first in handle common circles
6.removed game protected function PetFollow() after leave combat
7.removed spec-pet focus switch to single target within boss battle
8.add player power details member variable&refactor code
9.fixed spec-pet part of dungeon boss spell not working well
10.add no combat pet tips when player's pet not activing
11.add group aura data from game plugin make sure lqlxzh-fire first
12.refactor spell loader datas group by spec-hunter/spec-pet

version 2.2.4
1.update game plugin loop frame 30->60fps, interrupt tips show progress smooth
2.fixed player on idle state, count enemies issue, need 0.333sencods/frame
3.removed set personal facker gcd, need update reader(0) history logic code
4.universal battle properties to spellloader.lua file
5.update hunter const data, limit count enemies always 0.1sec, dungeon info max 0.6sec
6.fixed player battle on mythic, facker none boss enemies remind part of spells
7.fixed player falling floating state as moving and delay moving issue

version 2.2.3
1.update controller's single/multiple targets name to single/aoe
2.fixed player dead->alive auto switch to single target within encounter
3.adapted scenario broken available props, selected target invalid

version 2.2.2 release full
1.add limit player interrupt spell mzsj times for tips toggle off
2.add auto switch to single tips, when player selected special target
3.update client data transform peer-to-peer, avoid unknown data 
4.update player moving delay 1.0->1.5sec, it is game full gcd cdr
5.add boss encounter start force switch to single/multiple target&tips

version 2.2.1
1.update wow lua api check player was learn spell in spellbook
2.adapted 'Ara-Kara,City of Echoes' dungeon boss3 special spell
3.removed enter game event 'addon_loaded' call 'zone_change_new_area'
4.fixed check player talent spell jqsj need delay sync game data
5.update player talent tips when play enter dungeon or main area
6.update player only in mythic dungeon exit battle auto toggle off

version 2.2.0
1.update set greater zero condition 0.05>0.01 avoid spell queue
2.removed auto toggle off unmount when player on main area
3.feaute, add hook win key assistant player press key down
4.add global fixed circles when gcd finish press custom first
5.fixed hook keyboard event game character can't accept inputs
6.multiple available conditions make sure assistant keypress value

version 2.1.9
1.removed multiple targets add aura jqsj use dcsj delay issue
2.used instance spell hsj replaced of delay spell dcsj
3.removed cast normal spell hsj need damage buff dwxf require
4.fixed sync spell jssj&bfbz can't reference on lua script
5.feature, add free moving within 1 sec when player on batting
6.fixed player on main area finish task always toggle off circle
7.add player enter dungeon reset plugin status(toggle off)
8.fixed facker adapter not work well because order issue
9.split cast spell jssj within aura bfbz multiple or single

version 2.1.8
1.removed player moving adapted, moving action single
2.adapted special dungeon 'Tazavesh Market' boss1 spell
3.update spell faker limit bzsj value precent 2->4
4.fixed different language pass value precision issue
5.feature, interrupt manual rappid spell jssj enought buffs
6.update hunter talent, extra 2 multiple target -> haste

version 2.1.7
1.adapted special dungeon 'TheDwanbreaker' boss1/boss3 spell
2.adapted special dungeon 'So'leah's Gambit' boss1 spell
3.use milliseconds data handle timer instead of seconds timer


version 2.1.6 release full
1.set default game plugin options to humanization values
2.add game tips&ui when player don't use right talents
3.fixed circles when character low power cast spell issue
4.update readme.txt add character talent descriptions

version 2.1.5
1.fixed qprocess crash when use runtime embed python script
2.use signal/slot instead of lambda express make runtime stable
3.removed pre-circle logic code before game version 11.2
4.fixed game plugin can't count enemy count in time within mythic
5.fixed re-connect to network, client can't action normal
6.fixed dungeon of 'The Dawnbreaker' count idle npc enemy issue
7.try fixed player on raid read game spell data error, boos6+
8.add toggle off game plugin when boss battle encounter end

version 2.1.4
1.use arts game plugin icon instead of build-in interface icon
2.update game plugin information, sync with client rls
3.add tutorials tips when player import key setup
4.update readme.txt add character macro details desc
5.update email login verify digital code copyright info
6.use pyinstaller package pysmtp.py zip to executable
7.fixed use runtime pyscript send login email issue
8.fixed short timeout can't send email in time&profiler
9.fixed use sync wait data fallback on qprocess issue
10.fixed async signal/slot callback need alloc on stack
11.fixed register email sender multiple times when request
12.refactor client handler pre-thread unused codes

version 2.1.3 release full
1.add patch variable field for generate unique byte array
2.fixed use 1.pool.ntp.org reference time was current time
3.update readme.txt descriptions for latest release version
4.add startup check player whether need import key setup
5.removed player prop_1 useable tips when addon load
6.update user data storage struct use unique primary key
7.removed create shortcut inner client, reduce package size

version 2.1.2
1.fixed game interrupt macro using smart interrupt macro
2.update plugin serialized macro words sync version
3.send channel say chat message when cast spell mistake
4.removed words form client project, mythic&raid and qrc
5.schedule idle time backup user data/incremental backup
6.add user can create desktop shortcut from settings
7.fixed use ntp sync system time fail
8.fixed read process standard output empty
9.use merged channel instead of project issue codes


version 2.1.1
1.add talent edit plugin dialog ui shown require words
2.add color blocks set to top level with wow api
3.add game plugin option tips if not the right spec
4.add game gui copy talent edit text and test passed
5.using spell loader read combat state replace payload event
6.limited import setup key layout within combat state
7.update game plugin toc file head information
8.tooltip for import setup key button, show&hide


version 2.1.0
1.use spell loader instead of payload read moving state
2.set default clear target true when not face enemy
3.update game plugin info, hotkeyhelper to damagehelper
4.removed bfbz waiting 300ms for spell hsj reactor
5.refactor current datetime to universal utils utc fmt
6.add custom key import instead of third-part plugin myslot
7.update character lost ctrl slot decided by actionbar8
8.swap game key layout spell wgsj to bfbz
9.removed pre-think after bfbz cast spell hsj need wait 300ms


version 2.0.7
1.fixed startup main from updater behind of other windows
2.use function pointer instead of qt style SIGNAL/SLOT
3.refactor system tray show main window to widget manager
4.add moveable tips when player moveable within battle
5.add faker spell bzsj require hp 2% make sure combo done
6.fixed count enemies number issue about threat situation
7.use loop read game spell channel or casting instead of payload
8.add props/items/toy channel or casting was interrupted
9.set after cast bfbz wait 200ms, waiting for game reactor
10.fixed mult-circle after bfbz, cast hsq instead of mzsj


version 2.0.6 [11.2 gameplay basic]
1.refactor launcher check game client windows fetch hwnd logic
2.add open client unique instance limit, and dialog tips
3.fixed main loop delay initialized when check unique instance
4.adpate wow 11.2 basic mult target circles and tested pass
5.fixed cast spell ls anytime instead of need mzsj charge 1
6.rechecked game min power required, adapted to local circle
7.add spell ls cast limit by target hp base require precent 4
8.base gameplay loop circle aoe&single targets, passed new mythic
9.add new faker personal gcd for spell bfbz,mzsj,jssj,hsj temp


version 2.0.5
1.fixed cache game client hwnd timeout&invalid when grab it
2.game plugin decide target valid when OnMounted or OffMounted
3.game plugin add keyboard layout version tooltips
4.fixed already login user login duplicated from email issue
5.fixed data transfer waiting for flush, instead of signal
6.use function pointer instead of qt SIGNAL/SLOT macro
7.removed qapplication force exit with -1 instead of quit


version 2.0.4
1.fixed user bind new email re-generate acc & pwd auth issue
2.fixed login with email auth digital code timeout issue
3.ui, add label tips when sent digital code successful
4.universal app widget mgr initialize within entry main
5.removed redundancy widget managed by ctrl instead of 4
6.ui, use windows api fixed raise activate window failed
7.ui, user active windows forced line edit auto select all
8.adapted digital code email layout with mobile screen
9.add limit use activate code without email login

version 2.0.3
1.add system tray icon, simple menu windows min normal revert
2.ui, removed main window closeEvent show confirm exit dialog
3.ui, revert exit code force 1 instead of inner loop event
4.ui, removed raise and activate main window when open it
5.fixed monitor byte sent and receive count by seconds
6.fixed user charge statices left_second number error
7.add time server auth sync check local valid seconds
8.base on coro sync waiter or async poster handle user data
9.fixed count user update times when request version invalid
10.use task instead of qthread send auth user email code
11.fixed user switch account from email do not check state
12.removed remember acc&pwd login with email auth issue
13.fixed SmtpClient send email crash with compatible issue
14.add python3 tools set env & use it send html email
15.add fetch email digital code failed label tips
16.ui, set normal select all color for active code line edit
17.ui, active code invalid or active successful select all


version 2.0.2
1.use common persistent storage instead of file save
2.index key, use regex key instead of unique key
3.refeact code to common persistent storage style
4.replace all of local time to universal time
5.use reference personal IpAddress instead of copy
6.wrapper generate code inside of QCoroTask thread pool
7.ui, fixed login with email bind app windows dismiss
8.removed auto login with email while config with email
9.ui, add login with email details label tips
10.fixed login with email assert qstring empty failed
11.fixed line edit may be crash use validator api
12.fixed qstring ctor from qbytearray on gdb exception


version 2.0.1
1.fixed read target health state require exists
2.fixed find target aura require target exists
3.fixed target check valid require target exists
4.increment target scan debuff aura count 5->10
5.two patterns set scan aura num, raid and others
6.ui, fixed reopen settings page revert words button


version 2.0.0
1.replace qt multimedia play sound effect to windows api
2.reduce windeployqt release zip archive package size
3.set default open/close sound tips value to false
4.replace game api UnitIsDead decide by target hp


version 1.9.9
1.fixed active code remove(char) qstring bug
2.use transaction make user active data more safety
3.add active code retry tips when error occurred
4.fixed count user active code times increment by 1


version 1.9.8
1.add server interval monitor time up to half-hour
2.reduce server log oauth request times
3.fixed qt ui style not compatible on Windows11 24H2
4.fixed game plugin count wood target up to 40 nameplaters
5.adapted settings ui component width on Windows11


version 1.9.7
1.fixed game plugin decide enemy count the open time
2.fixed only calc wood target on main area
ready for 11.2 season3, ptr check details spells.

version 1.9.6
1.fixed already bind email account rebind error
2.fixed login email duplicated bind same email
3.removed label edit empty space while get the text()
4.reused ip address from IpPort personal struct
5.ui, email binding label edit increased width
6.ui, fixed login button click without input email tips
7.ui, only show email login widget when open it
8.ui, fixed hide login widget label info when close
9.game plugin add LAYOUT_VERSION and PLUGIN_VERSION flags
10.ui, align widgets center of parent, forward or back

version 1.9.5
1.fixed player floating state repeat pressed keyboard
2.smtp client define toggle off unused debug informations
3.update server logon type add options emial auth
4.update database colomns add email present store
5.fixed server auth generate new username and password
6.feature, client add email bind, login with email
7.define QT_NO_DEBUG with cmake replace within *.cpp


version 1.9.1
1.fixed login passed repeat instance period and oauth
2.fixed oauth interval signal error when disconnected
3.update Myslot plugin, add myslot license description
4.change part of qstring operator do not use pointer
5.add first open dialog usage text docs intro new user
6.packed damage helper app in exe with InnoSetup

version 1.9.0
1.fixed reconnect duplicated login exception
2.plugin add hp cast spell limit, owner the main loop
3.improve client tick update reference feature pixel
4.improve app hub settings reference addon path
5.updater add root directory unzip for text files

history 0.1.0
1.beast mastery it seems better spec to try

history 0.0.5
1.client app auto cast sequence on wood target used spec mage
2.try find a better spec to finish mythic or scenario once

history 0.0.3
1.base mage-fire sequence think used c# language
2.send keyboard event to game and Test OK
3.two way terminal client style, winform ui & console logic
4.try build wow plugin and read available spell data